#include <optional>
#include <string>

std::optional<int> name2errno(const std::string &str)
{
    std::string ucstr(str);
    for (auto &c : ucstr) c = toupper(c);

    if (ucstr == "EPERM") return 1;
    else if (ucstr == "ENOENT") return 2;
    else if (ucstr == "ESRCH") return 3;
    else if (ucstr == "EINTR") return 4;
    else if (ucstr == "EIO") return 5;
    else if (ucstr == "ENXIO") return 6;
    else if (ucstr == "E2BIG") return 7;
    else if (ucstr == "ENOEXEC") return 8;
    else if (ucstr == "EBADF") return 9;
    else if (ucstr == "ECHILD") return 10;
    else if (ucstr == "EAGAIN") return 11;
    else if (ucstr == "ENOMEM") return 12;
    else if (ucstr == "EACCES") return 13;
    else if (ucstr == "EFAULT") return 14;
    else if (ucstr == "ENOTBLK") return 15;
    else if (ucstr == "EBUSY") return 16;
    else if (ucstr == "EEXIST") return 17;
    else if (ucstr == "EXDEV") return 18;
    else if (ucstr == "ENODEV") return 19;
    else if (ucstr == "ENOTDIR") return 20;
    else if (ucstr == "EISDIR") return 21;
    else if (ucstr == "EINVAL") return 22;
    else if (ucstr == "ENFILE") return 23;
    else if (ucstr == "EMFILE") return 24;
    else if (ucstr == "ENOTTY") return 25;
    else if (ucstr == "ETXTBSY") return 26;
    else if (ucstr == "EFBIG") return 27;
    else if (ucstr == "ENOSPC") return 28;
    else if (ucstr == "ESPIPE") return 29;
    else if (ucstr == "EROFS") return 30;
    else if (ucstr == "EMLINK") return 31;
    else if (ucstr == "EPIPE") return 32;
    else if (ucstr == "EDOM") return 33;
    else if (ucstr == "ERANGE") return 34;
    else if (ucstr == "EDEADLK") return 35;
    else if (ucstr == "ENAMETOOLONG") return 36;
    else if (ucstr == "ENOLCK") return 37;
    else if (ucstr == "ENOSYS") return 38;
    else if (ucstr == "ENOTEMPTY") return 39;
    else if (ucstr == "ELOOP") return 40;
    else if (ucstr == "ENOMSG") return 42;
    else if (ucstr == "EIDRM") return 43;
    else if (ucstr == "ECHRNG") return 44;
    else if (ucstr == "EL2NSYNC") return 45;
    else if (ucstr == "EL3HLT") return 46;
    else if (ucstr == "EL3RST") return 47;
    else if (ucstr == "ELNRNG") return 48;
    else if (ucstr == "EUNATCH") return 49;
    else if (ucstr == "ENOCSI") return 50;
    else if (ucstr == "EL2HLT") return 51;
    else if (ucstr == "EBADE") return 52;
    else if (ucstr == "EBADR") return 53;
    else if (ucstr == "EXFULL") return 54;
    else if (ucstr == "ENOANO") return 55;
    else if (ucstr == "EBADRQC") return 56;
    else if (ucstr == "EBADSLT") return 57;
    else if (ucstr == "EBFONT") return 59;
    else if (ucstr == "ENOSTR") return 60;
    else if (ucstr == "ENODATA") return 61;
    else if (ucstr == "ETIME") return 62;
    else if (ucstr == "ENOSR") return 63;
    else if (ucstr == "ENONET") return 64;
    else if (ucstr == "ENOPKG") return 65;
    else if (ucstr == "EREMOTE") return 66;
    else if (ucstr == "ENOLINK") return 67;
    else if (ucstr == "EADV") return 68;
    else if (ucstr == "ESRMNT") return 69;
    else if (ucstr == "ECOMM") return 70;
    else if (ucstr == "EPROTO") return 71;
    else if (ucstr == "EMULTIHOP") return 72;
    else if (ucstr == "EDOTDOT") return 73;
    else if (ucstr == "EBADMSG") return 74;
    else if (ucstr == "EOVERFLOW") return 75;
    else if (ucstr == "ENOTUNIQ") return 76;
    else if (ucstr == "EBADFD") return 77;
    else if (ucstr == "EREMCHG") return 78;
    else if (ucstr == "ELIBACC") return 79;
    else if (ucstr == "ELIBBAD") return 80;
    else if (ucstr == "ELIBSCN") return 81;
    else if (ucstr == "ELIBMAX") return 82;
    else if (ucstr == "ELIBEXEC") return 83;
    else if (ucstr == "EILSEQ") return 84;
    else if (ucstr == "ERESTART") return 85;
    else if (ucstr == "ESTRPIPE") return 86;
    else if (ucstr == "EUSERS") return 87;
    else if (ucstr == "ENOTSOCK") return 88;
    else if (ucstr == "EDESTADDRREQ") return 89;
    else if (ucstr == "EMSGSIZE") return 90;
    else if (ucstr == "EPROTOTYPE") return 91;
    else if (ucstr == "ENOPROTOOPT") return 92;
    else if (ucstr == "EPROTONOSUPPORT") return 93;
    else if (ucstr == "ESOCKTNOSUPPORT") return 94;
    else if (ucstr == "EOPNOTSUPP") return 95;
    else if (ucstr == "EPFNOSUPPORT") return 96;
    else if (ucstr == "EAFNOSUPPORT") return 97;
    else if (ucstr == "EADDRINUSE") return 98;
    else if (ucstr == "EADDRNOTAVAIL") return 99;
    else if (ucstr == "ENETDOWN") return 100;
    else if (ucstr == "ENETUNREACH") return 101;
    else if (ucstr == "ENETRESET") return 102;
    else if (ucstr == "ECONNABORTED") return 103;
    else if (ucstr == "ECONNRESET") return 104;
    else if (ucstr == "ENOBUFS") return 105;
    else if (ucstr == "EISCONN") return 106;
    else if (ucstr == "ENOTCONN") return 107;
    else if (ucstr == "ESHUTDOWN") return 108;
    else if (ucstr == "ETOOMANYREFS") return 109;
    else if (ucstr == "ETIMEDOUT") return 110;
    else if (ucstr == "ECONNREFUSED") return 111;
    else if (ucstr == "EHOSTDOWN") return 112;
    else if (ucstr == "EHOSTUNREACH") return 113;
    else if (ucstr == "EALREADY") return 114;
    else if (ucstr == "EINPROGRESS") return 115;
    else if (ucstr == "ESTALE") return 116;
    else if (ucstr == "EUCLEAN") return 117;
    else if (ucstr == "ENOTNAM") return 118;
    else if (ucstr == "ENAVAIL") return 119;
    else if (ucstr == "EISNAM") return 120;
    else if (ucstr == "EREMOTEIO") return 121;
    else if (ucstr == "EDQUOT") return 122;
    else if (ucstr == "ENOMEDIUM") return 123;
    else if (ucstr == "EMEDIUMTYPE") return 124;
    else if (ucstr == "ECANCELED") return 125;
    else if (ucstr == "ENOKEY") return 126;
    else if (ucstr == "EKEYEXPIRED") return 127;
    else if (ucstr == "EKEYREVOKED") return 128;
    else if (ucstr == "EKEYREJECTED") return 129;
    else if (ucstr == "EOWNERDEAD") return 130;
    else if (ucstr == "ENOTRECOVERABLE") return 131;
    else if (ucstr == "ERFKILL") return 132;
    else if (ucstr == "EHWPOISON") return 133;
    else return std::nullopt;
}

const std::string errno2name(int num)
{
    switch (num) {
        case 1: return "EPERM";
        case 2: return "ENOENT";
        case 3: return "ESRCH";
        case 4: return "EINTR";
        case 5: return "EIO";
        case 6: return "ENXIO";
        case 7: return "E2BIG";
        case 8: return "ENOEXEC";
        case 9: return "EBADF";
        case 10: return "ECHILD";
        case 11: return "EAGAIN";
        case 12: return "ENOMEM";
        case 13: return "EACCES";
        case 14: return "EFAULT";
        case 15: return "ENOTBLK";
        case 16: return "EBUSY";
        case 17: return "EEXIST";
        case 18: return "EXDEV";
        case 19: return "ENODEV";
        case 20: return "ENOTDIR";
        case 21: return "EISDIR";
        case 22: return "EINVAL";
        case 23: return "ENFILE";
        case 24: return "EMFILE";
        case 25: return "ENOTTY";
        case 26: return "ETXTBSY";
        case 27: return "EFBIG";
        case 28: return "ENOSPC";
        case 29: return "ESPIPE";
        case 30: return "EROFS";
        case 31: return "EMLINK";
        case 32: return "EPIPE";
        case 33: return "EDOM";
        case 34: return "ERANGE";
        case 35: return "EDEADLK";
        case 36: return "ENAMETOOLONG";
        case 37: return "ENOLCK";
        case 38: return "ENOSYS";
        case 39: return "ENOTEMPTY";
        case 40: return "ELOOP";
        case 42: return "ENOMSG";
        case 43: return "EIDRM";
        case 44: return "ECHRNG";
        case 45: return "EL2NSYNC";
        case 46: return "EL3HLT";
        case 47: return "EL3RST";
        case 48: return "ELNRNG";
        case 49: return "EUNATCH";
        case 50: return "ENOCSI";
        case 51: return "EL2HLT";
        case 52: return "EBADE";
        case 53: return "EBADR";
        case 54: return "EXFULL";
        case 55: return "ENOANO";
        case 56: return "EBADRQC";
        case 57: return "EBADSLT";
        case 59: return "EBFONT";
        case 60: return "ENOSTR";
        case 61: return "ENODATA";
        case 62: return "ETIME";
        case 63: return "ENOSR";
        case 64: return "ENONET";
        case 65: return "ENOPKG";
        case 66: return "EREMOTE";
        case 67: return "ENOLINK";
        case 68: return "EADV";
        case 69: return "ESRMNT";
        case 70: return "ECOMM";
        case 71: return "EPROTO";
        case 72: return "EMULTIHOP";
        case 73: return "EDOTDOT";
        case 74: return "EBADMSG";
        case 75: return "EOVERFLOW";
        case 76: return "ENOTUNIQ";
        case 77: return "EBADFD";
        case 78: return "EREMCHG";
        case 79: return "ELIBACC";
        case 80: return "ELIBBAD";
        case 81: return "ELIBSCN";
        case 82: return "ELIBMAX";
        case 83: return "ELIBEXEC";
        case 84: return "EILSEQ";
        case 85: return "ERESTART";
        case 86: return "ESTRPIPE";
        case 87: return "EUSERS";
        case 88: return "ENOTSOCK";
        case 89: return "EDESTADDRREQ";
        case 90: return "EMSGSIZE";
        case 91: return "EPROTOTYPE";
        case 92: return "ENOPROTOOPT";
        case 93: return "EPROTONOSUPPORT";
        case 94: return "ESOCKTNOSUPPORT";
        case 95: return "EOPNOTSUPP";
        case 96: return "EPFNOSUPPORT";
        case 97: return "EAFNOSUPPORT";
        case 98: return "EADDRINUSE";
        case 99: return "EADDRNOTAVAIL";
        case 100: return "ENETDOWN";
        case 101: return "ENETUNREACH";
        case 102: return "ENETRESET";
        case 103: return "ECONNABORTED";
        case 104: return "ECONNRESET";
        case 105: return "ENOBUFS";
        case 106: return "EISCONN";
        case 107: return "ENOTCONN";
        case 108: return "ESHUTDOWN";
        case 109: return "ETOOMANYREFS";
        case 110: return "ETIMEDOUT";
        case 111: return "ECONNREFUSED";
        case 112: return "EHOSTDOWN";
        case 113: return "EHOSTUNREACH";
        case 114: return "EALREADY";
        case 115: return "EINPROGRESS";
        case 116: return "ESTALE";
        case 117: return "EUCLEAN";
        case 118: return "ENOTNAM";
        case 119: return "ENAVAIL";
        case 120: return "EISNAM";
        case 121: return "EREMOTEIO";
        case 122: return "EDQUOT";
        case 123: return "ENOMEDIUM";
        case 124: return "EMEDIUMTYPE";
        case 125: return "ECANCELED";
        case 126: return "ENOKEY";
        case 127: return "EKEYEXPIRED";
        case 128: return "EKEYREVOKED";
        case 129: return "EKEYREJECTED";
        case 130: return "EOWNERDEAD";
        case 131: return "ENOTRECOVERABLE";
        case 132: return "ERFKILL";
        case 133: return "EHWPOISON";
        default: return "<unknown>";
    }
}
